/*
 *  @version 	        @(#)SystemProperties.java	1.3 98/07/28
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

public class SystemProperties {

  public final static String[] vars = {
    "java.home",
    "java.class.path",
    "file.separator",
    "path.separator",
    "user.name",
    "user.home",
    "user.dir",
    "java.version",
    "java.vendor",
    "java.class.version",
    "os.name",
    "os.arch",
    "os.version",
    "java.sys.class.path"
  };

  public static void main(String[] args){
    for(int i=0;i<vars.length;i++){
      System.out.println(vars[i]+" = "+System.getProperty(vars[i]));
    }
  }
}
